import unittest
from Products.XMLWidgets.EditorService import EditorCache

    
class EditorCacheTestCase(unittest.TestCase):
    def setUp(self):
        self.cache = EditorCache()

    def test_cache(self):
        self.cache.cache(1, 1, 1, 'foo')
        self.assertEquals('foo', self.cache.getCached(1, 1, 1))

    def test_notCached(self):
        self.assertEquals(None, self.cache.getCached(1, 1, 1))
        
    def test_invalidate(self):
        self.cache.cache(1, 1, 1, 'foo')
        self.cache.invalidate(1, 1, 1)
        self.assertEquals(None, self.cache.getCached(1, 1, 1))

    def test_clearDocument(self):
        self.cache.cache(1, 1, 1, 'foo')
        self.cache.cache(1, 2, 3, 'bar')
        self.cache.clearDocument(1)
        self.assertEquals(None, self.cache.getCached(1, 1, 1))
        self.assertEquals(None, self.cache.getCached(1, 2, 3))

    def test_clear(self):
        self.cache.cache(1, 1, 1, 'foo')
        self.cache.cache(1, 2, 3, 'bar')
        self.cache.cache(2, 1, 1, 'baz')
        self.cache.clear()
        self.assertEquals(None, self.cache.getCached(1, 1, 1))
        self.assertEquals(None, self.cache.getCached(1, 2, 3))
        self.assertEquals(None, self.cache.getCached(2, 1, 1))

    # def test_compact(self): XXX wish I knew how
        
    
def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(EditorCacheTestCase, 'test'))
    return suite

def main():
    unittest.TextTestRunner().run(test_suite())

if __name__ == '__main__':
    main()
